@use crate::iter::IdentifyLast;
@use crate::templates::base_html;
@use crate::format_kbytes;
@use crate::crev_audit::AuditsPage;
@use crate::crev_audit::ReviewSet;
@use crate::crev_audit::Rating;
@use crate::Urler;

@(url: &Urler, c: &AuditsPage<'_>)

@:base_html(&c.page(), {
  <header id="creviews" @if c.ver.is_yanked() {class="yanked"} else {@if c.ver.is_nightly() {class="nightly"}}>
    <div class="inner-col">
    <div class="breadcrumbs">
    <h1>
      <a href="/"><span>Lib</span>.rs</a>
    </h1>
     › <a href="@url.krate(c.ver)" rel="up">@c.ver.capitalized_name()</a>
     › Reviews
    </div>
    <nav><ul>
        <li class=active>Reviews</li>
        <li><a href="@url.crate_by_origin(&c.cargo_crev_origin)">cargo-crev</a></li>
        <li><a href="@url.crate_by_origin(&c.cargo_vet_origin)">cargo-vet</a></li>
        <li><a href="@url.crate_by_origin(&c.cargo_audit_origin)">cargo-audit</a></li>
    </ul></nav>
    </div>
  </header>
  <main>
    <div class="inner-col">
        @if !c.advisories.is_empty() {
            <div class="reviews">
                @for a in &c.advisories {
                    <article>
                        <div class=h><a href='@a.id().url().as_deref().unwrap_or("https://rustsec.org/")'>@a.id().as_str()
                        @if let Some(inf) = &a.metadata.informational {
                            (@inf.as_str())
                        }
                        </a> on @a.date().as_str(): @c.render_title(a.title())</div>
                        <div class=comment>
                            @c.render_comment(a.description())

                            @for r in &a.metadata.references {
                                <p><a href="@r" rel="ugc">@r</a></p>
                            }
                            @for a in &a.metadata.aliases {
                                @if let Some(url) = a.url() { <p><a href="@url" rel="ugc">@a.as_str()</a></p> }
                            }
                        </div>
                    </article>
                }
            </div>
        }
        @if c.crev_reviews.is_empty() && c.vet_reviews.is_empty() {
            <p class="error">This crate has no reviews yet. To add a review, <a href="@url.install(&c.cargo_crev_origin)">set up your <code>cargo-crev</code></a>.</p>
        }
        <div class="reviews">
        @for (i, set) in c.reviews_order.iter().copied().enumerate() {
            @if set == ReviewSet::Crev {
                @if !c.crev_reviews.is_empty() {
                    @if i > 0 {
                        <hr>
                    }
                    <p>@if c.crev_reviews.len() > 1 {These reviews are} else {This review is} from <a href="@url.crate_by_origin(&c.cargo_crev_origin)">Crev, a distributed system for code reviews</a>. To add your review, <a href="@url.install(&c.cargo_crev_origin)">set up <code>cargo-crev</code></a>.</p>
                }
                @for (fold, latest_warn, r) in &c.crev_reviews {
                    @if *latest_warn {
                        <p>The current version of @c.ver.capitalized_name() is <span class=version>@c.ver.version()</span>.</p>
                    }
                    <article class="@c.version_compare(&r.version).0 @if r.comment_markdown.trim_start().is_empty() && r.issues.is_empty() {no-text}">
                        <div class=h>
                            <p class=for><span class=version>@r.version <span>@c.version_compare(&r.version).1</span></span>
                                <span class=rating>Rating: <span class="@c.rating_class(r.rating)">@c.rating_label(r.rating)
                                    @if r.unmaintained { + Unmaintained }
                                </span></span>
                                <span class=thoroughness>Thoroughness: <span class="@c.level_class(r.thoroughness)">@c.level_label(r.thoroughness)</span></span>
                                <span class=understanding>Understanding: <span class="@c.level_class(r.understanding)">@c.level_label(r.understanding)</span></span>
                            </p>
                            <p class=by>
                                @if (r.rating == Rating::Positive || r.rating == Rating::Strong) && r.comment_markdown.trim_start().is_empty() && r.issues.is_empty() { Approved without comment }
                                by @if let Some(author_url) = r.author_url.as_ref() {
                                    <a rel="nofollow ugc noopener" href="@author_url#@r.author_id">@c.author_name(r)</a>
                                } else {
                                    @c.author_name(r)
                                }
                                on <span class="date">@r.date.format("%Y-%m-%d")</span>
                            </p>
                        </div>
                        @if !r.comment_markdown.trim_start().is_empty() || !r.issues.is_empty() {
                            @if *fold {<details><summary>Show review…</summary>}
                            <div class="comment">
                                @if !r.comment_markdown.trim_start().is_empty() {
                                    @c.render_comment(&r.comment_markdown)
                                }

                                @if !r.issues.is_empty() {
                                    <ul>
                                        @for issue in &r.issues {
                                            <li>
                                                <p>
                                                    <span class=issue-label>Issue:</span> @c.level_label(issue.severity)
                                                    @for id in &issue.ids {
                                                        @if let Some(issue_url) = c.issue_url(id) {
                                                            (<a href="@issue_url" rel="nofollow ugc noopener">@c.issue_id(id)</a>)
                                                        } else {
                                                            (@c.issue_id(id))
                                                        }
                                                    }
                                                </p>
                                                @if !issue.comment_markdown.trim_start().is_empty() {
                                                    @c.render_comment(&issue.comment_markdown)
                                                }
                                            </li>
                                        }
                                    </ul>
                                }
                            </div>
                            @if *fold {</details>}
                        }
                    </article>
                }
            }
            @if set == ReviewSet::Vet {
                @if !c.vet_reviews.is_empty() {
                    @if i > 0 {
                        <hr>
                    }
                    <p>@if c.vet_reviews.len() > 1 {These reviews are} else {This review is} from <a href="@url.crate_by_origin(&c.cargo_vet_origin)">cargo-vet</a>. To add your review, <a href="@url.install(&c.cargo_vet_origin)">set up <code>cargo-vet</code></a> and submit your URL to its <a href="https://github.com/mozilla/cargo-vet/blob/main/registry.toml">registry</a>.</p>
                }

                @for r in &c.vet_reviews { @if let Some((klass, verlabel)) = c.version_compare_opt(r.semver.as_ref()) {
                    @if r.latest_warn {
                        <p>The current version of @c.ver.capitalized_name() is <span class=version>@c.ver.version()</span>.</p>
                    }

                    <article class="@klass @if r.r.notes().is_none() {no-text}">
                        <div class=h>
                            <p class=for>
                                <span class=version>@if let Some(vi) = r.r.violation() { Affects @vi } else { @if let Some(v) = r.r.version() {
                                    @v.version
                                    @if let Some((url, label)) = c.git_url_for_vet_version(v) {
                                        <a rel="nofollow ugc noopener" href="@url">@label</a>
                                    }
                                } else {*} }
                                    @if let Some((fr, _)) = r.r.delta() {
                                        — diff review from @fr.version
                                        @if let Some((url, label)) = c.git_url_for_vet_version(fr) {
                                            <a rel="nofollow ugc noopener" href="@url">@label</a>
                                        }
                                        only
                                    }
                                <span>@verlabel</span></span>
                                <span class=rating><span class="@c.rating_class_vet(&r.r)">
                                    @for (last, c) in r.r.criteria().iter().identify_last() {
                                        <a href="#criterion-@c" class=crit>@c</a>@if !last {,}
                                    }
                                </span></span>
                            </p>
                            <p class=by>
                                From @if let Some((u, repo)) = r.r.src.github_repo() { <a rel="nofollow ugc noopener" href="@url.crate_owner_by_github_login(u)" title="@r.r.src.name">@u</a>/<a rel="nofollow ugc noopener" href="@r.r.src.url">@repo</a>} else { <a rel="nofollow ugc noopener" href="@r.r.src.view_url()" title="@r.r.src.name">@r.r.src.host()</a>}@if let Some(ag) = &r.r.aggregated_from_host() { copy of <a rel="nofollow ugc noopener" href="@r.r.aggregated_from().as_ref().get(0).map(|s| s.as_str()).unwrap_or_default()">@ag</a>}.
                                @if r.r.notes().is_none() { @r.r.audit_type_label() without comment by } else { @if !r.authors.is_empty() { By } }
                                @for (last, (a_url, a_name)) in r.authors.iter().identify_last() {
                                    @if let Some(a_url) = a_url {
                                        <a rel="nofollow ugc noopener" href="@a_url">@a_name</a>} else {
                                        @a_name}@if !last {,}}@if let Some(s) = r.r.start() { on @s}@if !r.authors.is_empty() || r.r.start().is_some() {.}
                            </p>
                        </div>
                        @if let Some(notes) = r.r.notes() {
                            @if r.fold {<details><summary>Show review…</summary>}
                            <div class="comment">
                                @c.render_comment(notes)
                            </div>
                            @if r.fold {</details>}
                        }
                    </article>
                }}
                @if !c.vet_reviews.is_empty() {
                    <p><small>cargo-vet does not verify reviewers' identity. You have to fully trust the source the audits are from.</small></p>
                    @if !c.vet_legend.is_empty() {
                        <dl class=legend>
                        @for l in &c.vet_legend {
                            <dt id="criterion-@l.criterion_name" title="from @if let Some(ag) = l.aggregated_from_host {@ag via }@l.src.name">@l.criterion_name
                                @if !l.implies.is_empty() {
                                    <span>(implies @for i in &l.implies { <a href="#criterion-@i" class=crit>@i</a>})</span>
                                }
                            </dt>
                            <dd>@if l.fold {<details><summary>Implied by other criteria</summary>}
                                <p>@c.render_comment(&l.desc)</p>
                                @if l.fold {</details>}
                            </dd>
                        }
                        </dl>
                    }
                }
            }
        }
        </div>

        @if let Some(tarball_url) = c.crate_tarball_download_url.as_deref() {
            <hr>
            @if let Some((true, res)) = c.repo_report.as_ref().map(|r| r.result()).map(|res| (res.all_files_verified, res)) {
                <p>Lib.rs has been able to verify that all files in the crate's tarball@if res.cargo_lock_skipped {, except <code>Cargo.lock</code>,}
                are in the crate's repository@if res.has_a_good_tag { with a git tag matching the version}. Please note that this check is still in beta, and absence of this confirmation does not mean that the files don't match.</p>

                <p>Crates in the crates.io registry are tarball snapshots uploaded by crates' publishers. The registry is not using crates' git repositories, so there is a possibility that published crates have a misleading repository URL, or contain different code from the code in the repository.</p>
            } else {
                <p>Crates in the crates.io registry are tarball snapshots uploaded by crates' publishers. The registry is not using crates' git repositories. There is absolutely no guarantee that the repository URL declared by the crate belongs to the crate, or that the code in the repository is the code inside the published tarball.</p>
            }
            <p>To review the actual code of the crate, it's best to use <code>cargo <a href="@url.crate_by_origin(&c.cargo_crev_origin)">crev</a> open @c.ver.short_name()</code>. Alternatively, you can <a href="@tarball_url" rel="noindex nofollow" download="@(c.ver.short_name())-@(c.ver.version()).crate.tar.gz">download the tarball of @c.ver.short_name() v@c.ver.version()</a> or <a rel="nofollow" href="@url.docs_rs_source(c.ver.short_name(), c.ver.version())">view the source online</a>.</p>
            </p>
        }

        @if !c.suspicious_binary_files.is_empty() {
            <section>
                <p>The crate tarball contains, among others, @if c.suspicious_binary_files.len()==1 {this file} else {these files}:</p>
                <ul>
                    @for f in &c.suspicious_binary_files {
                        <li class="sus-files"><b>@f.kind</b>, @format_kbytes(f.size): <span>@f.path.display()</span></li>
                    }
                </ul>
            </section>
        }
    </div>
  </main>

  <footer>
    <div class="inner-col">
        <p>Back to <a href="@url.krate(c.ver)" rel="up">@c.ver.capitalized_name()</a>.</p>
    </div>
  </footer>
})
